"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SegmentPlugin = void 0;
/* eslint-disable no-unused-vars, class-methods-use-this */
var analytics_react_native_1 = __importDefault(require("@segment/analytics-react-native"));
var sdk_1 = require("@itly/sdk");
/**
 * Segment React Native Plugin for Iteratively SDK
 */
var SegmentPlugin = /** @class */ (function (_super) {
    __extends(SegmentPlugin, _super);
    function SegmentPlugin(writeKey, options) {
        var _this = _super.call(this, 'segment') || this;
        _this.writeKey = writeKey;
        _this.options = options;
        return _this;
    }
    SegmentPlugin.prototype.load = function (options) {
        _super.prototype.load.call(this, options);
        analytics_react_native_1.default.setup(this.writeKey, this.options);
    };
    SegmentPlugin.prototype.alias = function (userId, previousId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var segmentOptions, responseLogger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        segmentOptions = (options !== null && options !== void 0 ? options : {}).options;
                        responseLogger = this.logger.logRequest('alias', userId + ", " + previousId);
                        return [4 /*yield*/, analytics_react_native_1.default.alias(userId, segmentOptions)];
                    case 1:
                        _a.sent();
                        responseLogger.success('done');
                        return [2 /*return*/];
                }
            });
        });
    };
    SegmentPlugin.prototype.identify = function (userId, properties, options) {
        return __awaiter(this, void 0, void 0, function () {
            var segmentOptions, responseLogger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        segmentOptions = (options !== null && options !== void 0 ? options : {}).options;
                        responseLogger = this.logger.logRequest('identify', userId + ", " + JSON.stringify(properties));
                        return [4 /*yield*/, analytics_react_native_1.default.identify(userId != null ? userId : null, properties, segmentOptions)];
                    case 1:
                        _a.sent();
                        responseLogger.success('done');
                        return [2 /*return*/];
                }
            });
        });
    };
    SegmentPlugin.prototype.group = function (userId, groupId, properties, options) {
        return __awaiter(this, void 0, void 0, function () {
            var segmentOptions, responseLogger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        segmentOptions = (options !== null && options !== void 0 ? options : {}).options;
                        responseLogger = this.logger.logRequest('group', userId + ", " + groupId + ", " + JSON.stringify(properties));
                        return [4 /*yield*/, analytics_react_native_1.default.group(groupId, properties, segmentOptions)];
                    case 1:
                        _a.sent();
                        responseLogger.success('done');
                        return [2 /*return*/];
                }
            });
        });
    };
    SegmentPlugin.prototype.page = function (userId, category, name, properties, options) {
        return __awaiter(this, void 0, void 0, function () {
            var segmentOptions, responseLogger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        segmentOptions = (options !== null && options !== void 0 ? options : {}).options;
                        responseLogger = this.logger.logRequest('page', userId + ", " + category + ", " + name + ", " + JSON.stringify(properties));
                        return [4 /*yield*/, analytics_react_native_1.default.screen(name, properties, segmentOptions)];
                    case 1:
                        _a.sent();
                        responseLogger.success('done');
                        return [2 /*return*/];
                }
            });
        });
    };
    SegmentPlugin.prototype.track = function (userId, _a, options) {
        var name = _a.name, properties = _a.properties;
        return __awaiter(this, void 0, void 0, function () {
            var segmentOptions, responseLogger;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        segmentOptions = (options !== null && options !== void 0 ? options : {}).options;
                        responseLogger = this.logger.logRequest('track', userId + ", " + name + ", " + JSON.stringify(properties));
                        return [4 /*yield*/, analytics_react_native_1.default.track(name, properties, segmentOptions)];
                    case 1:
                        _b.sent();
                        responseLogger.success('done');
                        return [2 /*return*/];
                }
            });
        });
    };
    SegmentPlugin.prototype.reset = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, analytics_react_native_1.default.reset()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    SegmentPlugin.prototype.flush = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, analytics_react_native_1.default.flush()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return SegmentPlugin;
}(sdk_1.RequestLoggerPlugin));
exports.SegmentPlugin = SegmentPlugin;
exports.default = SegmentPlugin;
